{
=============
TEComboButton
=============

Replacement for ComboBox with little items!!!

Copyright 09.1997 By MAD Soft

Telephone: Bulgaria, Sofia, 37-06-23
E_Mail:    NMMM@NSI.BG
           NMMM@MailCity.Com
           NMMM@HotMail.Com
           NMMM@WebMail.Co.ZA
Web:       Http:\\WWW.NSI.BG\NMMM\Home.Htm
}

unit Ecombbtn;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Buttons, Ebutton;

type
  TEComboButton = class(TESpeedButton)
  private
    { Private declarations }
    FItems     : TStringList;
    FItemIndex : Integer;
    FDefault   : String;

    Procedure   Click; override;
  protected
    { Protected declarations }
  public
    { Public declarations }

    Constructor Create(AOwner:TComponent); override;

    Procedure   SetItems(Items_:TStringList);
    Procedure   SetItemIndex(I:Integer);
    Procedure   SetDefault(S:String);
  published
    { Published declarations }

     Property Items        : TStringList  read FItems      write SetItems;
     Property ItemIndex    : Integer      read FItemIndex  write SetItemIndex;
     Property DefaultValue : String       read FDefault    write SetDefault;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Additional', [TEComboButton]);
end;

Constructor TEComboButton.Create(AOwner:TComponent);
   Begin
      Inherited Create(AOwner);
      FItems:=TStringList.Create;
      ItemIndex:=-1;
      DefaultValue:='';
   End;

Procedure   TEComboButton.SetItems(Items_:TStringList);
   Var I : Integer;
   begin
      FItems.Clear;
      If Items_.Count > 0 Then
         For I:=0 to Items_.Count - 1 do
            FItems.Add(Items_[I]);

      {IMPORTANT: the object itself cannot be added here}

      ItemIndex:=-1;
   End;

Procedure   TEComboButton.SetItemIndex(I:Integer);
   Begin
      If (I < -1          ) Or
         (FItems.Count = 0) Then
         FItemIndex:=-1
      Else
         If I > FItems.Count - 1 Then
            FItemIndex:=0
         Else
            FItemIndex:=I;

      If FItemIndex <> -1 Then
         Caption:=FItems[FItemIndex]
      Else
         Caption:=FDefault;
   End;

Procedure   TEComboButton.SetDefault(S:String);
   Begin
      FDefault:=S;
      ItemIndex:=ItemIndex; {Run Proc}
   End;

Procedure   TEComboButton.Click;
   Begin
      Inherited Click;
      ItemIndex:=ItemIndex + 1;
   End;

end.

